<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_content
 *
 * @copyright   Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

$params    = $this->item->params;
$images    = json_decode($this->item->images);

$document  = JFactory::getDocument();
$template  = JFactory::getApplication()->getTemplate(true);
$renderer  = JFactory::getDocument()->loadRenderer('modules');
$document->params = $template->params;
$document->template = $template->template;
$t3app     = T3::getApp($document);
?>
<?php
// Layout configuration
$layout_config = json_decode ('{
	"two_sidebars": {
		"default" : [ "span4 offset4" , "span4 offset-8"    , "span4"             ],
		"wide"    : [],
		"xtablet" : [],
		"tablet"  : [ "span12"        , "span6 spanfirst"   , "span6"             ]
	},
	"one_sidebar1": {
		"default" : [ "span8 has-sidebar1 pull-right"       , "span4"             ],
		"wide"    : [],
		"xtablet" : [ "span8 has-sidebar1 pull-right"       , "span4"             ],
		"tablet"  : [ "span12"        , "span12 spanfirst"  ]
	},
	"one_sidebar2": {
		"default" : [ "span8 has-sidebar2"                  , "span4"             ],
		"wide"    : [],
		"xtablet" : [ "span8 has-sidebar2"                  , "span4"             ],
		"tablet"  : [ "span12"        , "span12 spanfirst"  ]
	},
	"no_sidebar": {
		"default" : [ "span12"        ]
	}
}');

// positions configuration
$sidebar1 = 'sidebar-1';
$sidebar2 = 'sidebar-2';
  // Detect layout
if ($t3app->countModules("$sidebar1 and $sidebar2")) {
	$layout = 'two_sidebars';
} elseif ($t3app->countModules($sidebar1)) {
	$layout = 'one_sidebar1';
} elseif ($t3app->countModules($sidebar2)) {
	$layout = 'one_sidebar2';
} else {
	$layout = 'no_sidebar';
}
$layout = $layout_config->$layout;

$col = 0;
?>
<section class="article-content clearfix row">

	<div class="article-body <?php echo $t3app->getClass($layout, $col) ?>" <?php echo $t3app->getData ($layout, $col++) ?>>
		

		<?php if (isset($images->image_fulltext) && !empty($images->image_fulltext)) : ?>
			<?php
				$imgfloat = (empty($images->float_fulltext)) ? $this->item->params->get('float_fulltext') : $images->float_fulltext; 
			?>
			<div class="pull-<?php echo htmlspecialchars($imgfloat); ?> item-image">
				<img
				<?php if ($images->image_fulltext_caption): ?>
					<?php echo 'class="caption"'.' title="' .htmlspecialchars($images->image_fulltext_caption) .'"'; ?>
				<?php endif; ?>
				src="<?php echo htmlspecialchars($images->image_fulltext); ?>" alt="<?php echo htmlspecialchars($images->image_fulltext_alt); ?>"/>
			</div>
		<?php endif; ?>
		
		<?php if (isset ($this->item->toc)) : ?>
			<?php echo $this->item->toc; ?>
		<?php endif; ?>
	
		<?php echo $this->item->text; ?>

		<footer class="article-footer clearfix">
			<?php if ($params->get('show_modify_date')) : ?>
			<dl class="article-info pull-left">
				<dt class="article-info-term"><?php echo JText::_('TPL_ARTICLE_FOOTER_INFO'); ?></dt>
				<dd class="modified">
					<?php echo JText::sprintf('COM_CONTENT_LAST_UPDATED', '<span>'.JHtml::_('date', $this->item->modified, JText::_('DATE_FORMAT_LC3')).'</span>'); ?> 
				</dd>
			</dl>
			<?php endif; ?>
			<div class="tag-names pull-right">
				<?php if ($params->get('show_tags', 1) && !empty($this->item->tags)) : ?>
					<?php $this->item->tagLayout = new JLayoutFile('joomla.content.tags'); ?>
					<?php echo $this->item->tagLayout->render($this->item->tags->itemTags); ?>
				<?php endif; ?>
			</div>
		</footer>
				
		<?php if (!empty($this->item->pagination) && $this->item->pagination && $this->item->paginationposition && !$this->item->paginationrelative): ?>
			<hr class="divider-vertical" />
			<?php echo $this->item->pagination; ?>
		<?php endif; ?>

		<?php if (isset($urls) && ((!empty($urls->urls_position) && ($urls->urls_position=='1')) || ( $params->get('urls_position')=='1') )): ?>
			<?php echo $this->loadTemplate('links'); ?>
		<?php endif; ?>

		<?php if (!$params->get('access-view') && $params->get('show_noauth') == true and  $user->get('guest') ) : ?>

			<?php echo $this->item->introtext; ?>
			<?php //Optional link to let them register to see the whole article. ?>
			<?php if ($params->get('show_readmore') && $this->item->fulltext != null) :
				$link1 = JRoute::_('index.php?option=com_users&view=login');
				$link = new JURI($link1);
			?>
			<section class="readmore">
				<a href="<?php echo $link; ?>">
					<span>
					<?php $attribs = json_decode($this->item->attribs); ?>
					<?php
					if ($attribs->alternative_readmore == null) :
						echo JText::_('COM_CONTENT_REGISTER_TO_READ_MORE');
					elseif ($readmore = $this->item->alternative_readmore) :
						echo $readmore;
						if ($params->get('show_readmore_title', 0) != 0) :
							echo JHtml::_('string.truncate', ($this->item->title), $params->get('readmore_limit'));
						endif;
					elseif ($params->get('show_readmore_title', 0) == 0) :
						echo JText::sprintf('COM_CONTENT_READ_MORE_TITLE');
					else :
						echo JText::_('COM_CONTENT_READ_MORE');
						echo JHtml::_('string.truncate', ($this->item->title), $params->get('readmore_limit'));
					endif; ?>
					</span>
				</a>
			</section>
			<?php endif; ?>
		<?php endif; ?>
	</div>
	<?php if ($t3app->countModules($sidebar1)) : ?>
	<!-- SIDEBAR 1 -->
	<div class="t3-sidebar t3-sidebar-1 <?php echo $t3app->getClass($layout, $col) ?><?php $t3app->_c($sidebar1)?>" <?php echo $t3app->getData ($layout, $col++) ?>>
		<?php echo $renderer->render($t3app->getPosname($sidebar1), array('style' => 'T3Xhtml')) ?>
	</div>
	<!-- //SIDEBAR 1 -->
	<?php endif ?>

	<?php if ($t3app->countModules($sidebar2)) : ?>
	<!-- SIDEBAR 2 -->
	<div class="t3-sidebar t3-sidebar-2 <?php echo $t3app->getClass($layout, $col) ?><?php $t3app->_c($sidebar2)?>" <?php echo $t3app->getData ($layout, $col++) ?>>
		<?php echo $renderer->render($t3app->getPosname($sidebar2), array('style' => 'T3Xhtml')) ?>
	</div>
	<!-- //SIDEBAR 2 -->
	<?php endif ?>
</section>