<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_content
 *
 * @copyright   Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
JHtml::addIncludePath(JPATH_COMPONENT . '/helpers');
JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::addIncludePath(T3_PATH . '/html/com_content');
JHtml::addIncludePath(dirname(dirname(__FILE__)));

JHtml::_('behavior.caption');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.framework');

//register the helper class
JLoader::register('MagzHelper', T3_TEMPLATE_PATH . '/templateHelper.php');

//template params
$tplparams = JFactory::getApplication()->getTemplate(true)->params;
?>
<div class="tpl-inf-wrapper">

	<div class="blog<?php echo $this->pageclass_sfx; ?> events clearfix">
		<?php if ($this->params->get('show_page_heading', 1)) : ?>
			<div class="page-header clearfix">
				<h1 class="page-title"> <?php echo $this->escape($this->params->get('page_heading')); ?> </h1>
			</div>
		<?php endif; ?>

		<?php if ($this->params->get('show_category_title', 1) or $this->params->get('page_subheading')) : ?>
			<div class="page-subheader clearfix">
				<h2 class="page-subtitle"><?php echo $this->escape($this->params->get('page_subheading')); ?>
					<?php if ($this->params->get('show_category_title')) : ?>
						<small class="subheading-category"><?php echo $this->category->title; ?></small>
					<?php endif; ?>
				</h2>
			</div>
		<?php endif; ?>

		<?php if ($this->params->get('show_tags', 1) && !empty($this->category->tags->itemTags)) : ?>
			<?php $this->category->tagLayout = new JLayoutFile('joomla.content.tags'); ?>
			<?php echo $this->category->tagLayout->render($this->category->tags->itemTags); ?>
		<?php endif; ?>

		<?php if ($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) : ?>
			<div class="category-desc clearfix">
				<?php if ($this->params->get('show_description_image') && $this->category->getParams()->get('image')) : ?>
					<img src="<?php echo $this->category->getParams()->get('image'); ?>"/>
				<?php endif; ?>
				<?php if ($this->params->get('show_description') && $this->category->description) : ?>
					<?php echo JHtml::_('content.prepare', $this->category->description, '', 'com_content.category'); ?>
				<?php endif; ?>
			</div>
		<?php endif; ?>

		<?php /* if (!empty($this->lead_items)) : ?>
		<div class="items-leading">
			<?php foreach ($this->lead_items as &$item) : ?>
			<div class="leading leading-<?php echo $leadingcount; ?><?php echo $item->state == 0 ? ' system-unpublished' : null; ?>">
				<?php
					$this->item = &$item;
					echo $this->loadTemplate('item');
				?>
			</div>
			<?php endforeach; ?>
		</div>
		<?php endif; */
		?>

		<?php if (!empty($this->intro_items)) : ?>
			<?php $eventgroup = array(); ?>
			
			<div id="infinity-cont" class="infinity-cont event-container">

				<?php foreach ($this->intro_items as $key => &$item) : ?>
					<div class="items <?php echo $item->state == 0 ? ' system-unpublished' : null; ?> clearfix">
						<?php
							$this->item = &$item;
							echo $this->loadTemplate('item');
						?>
					</div>
				<?php endforeach; ?>

				<?php if ($tplparams->get('tpl_navigation_infinity', 1)) : ?>
					<?php if ($this->params->def('show_pagination', 2) == 1 || ($this->params->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>
						<nav id="page-nav" class="pagination">
							<?php
							$urlparams = '';
							if (!empty($this->pagination->_additionalUrlParams)) {
								foreach ($this->pagination->_additionalUrlParams as $key => $value) {
									$urlparams .= '&' . $key . '=' . $value;
								}
							}

							$next = $this->pagination->limitstart + $this->pagination->limit;
							$nextlink = JRoute::_($urlparams . '&' . $this->pagination->prefix . 'limitstart=' . $next);
							?>
							<a id="page-next-link" href="<?php echo $nextlink ?>"
							   data-limit="<?php echo $this->pagination->limit; ?>"
							   data-start="<?php echo $this->pagination->limitstart ?>"></a>
						</nav>
					<?php endif; ?>
				<?php endif; ?>
			</div>

			<?php if ($this->params->def('show_pagination', 2) == 1 || ($this->params->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>

				<?php if ($tplparams->get('tpl_navigation_infinity', 1)) : ?>
					<div id="infinity-next" class="infinity-next hidden">
						<div class="inf-loader">
							<img alt="<?php echo JText::_('TPL_INFINITY_NEXT')?>" src="<?php echo T3_TEMPLATE_URL ?>/images/ajax-load.gif">
						</div>
						<div class="inf-button">
							<?php echo JText::_('TPL_INFINITY_NEXT')?>
						</div>
					</div>
				<?php else : ?>
					<div class="pagination">

						<?php if ($this->params->def('show_pagination_results', 1)) : ?>
							<p class="counter pull-right">
								<?php echo $this->pagination->getPagesCounter(); ?>
							</p>
						<?php endif; ?>
						<?php echo $this->pagination->getPagesLinks(); ?>
					</div>
				<?php endif; ?>

			<?php endif; ?>
		<?php endif; ?>

		<?php /* if (!empty($this->link_items)) : ?>
			<div class="items-more">
				<?php echo $this->loadTemplate('links'); ?>
			</div>
			<hr class="divider-vertical"/>
		<?php endif; */ ?>

		<?php /* if (!empty($this->children[$this->category->id]) && $this->maxLevel != 0) : ?>
			<div class="cat-children">
				<?php if ($this->params->get('show_category_heading_title_text', 1) == 1) : ?>
					<h3> <?php echo JText::_('JGLOBAL_SUBCATEGORIES'); ?> </h3>
				<?php endif; ?>
				<?php echo $this->loadTemplate('children'); ?> </div>
		<?php endif; */ ?>

	</div>
</div>
