<?php
 /**
 * @package		Joomla.Site
 * @subpackage	com_contact
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

//template params
$tplparams  = JFactory::getApplication()->getTemplate(true)->params;

// Set application parameters in model
$app        = JFactory::getApplication();
$db         = JFactory::getDbo();
$rparams    = JComponentHelper::getParams('com_content');
$input      = $app->input;
$menuParams = new JRegistry();
if ($menu = $app->getMenu()->getActive()) {
	$menuParams->loadString($menu->params);
}
$rparams->merge($menuParams);

// Get an instance of the generic articles model
$articles = JModelLegacy::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

//params
$articles->setState('params', $rparams);

// Set the filters based on the module params
$articles->setState('list.start', $input->getUInt('limitstart', 0));
$articles->setState('list.limit', (int)$tplparams->get('tpl_media_related_articles', 12));
$articles->setState('filter.published', 1);

// Access filter
$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
$articles->setState('filter.access', $access);

// Filter content
$articles->setState('filter.article_id', array($this->item->id));
$articles->setState('filter.article_id.include', false); // Exclude

// Filter category
$articles->setState('filter.category_id', array($this->item->catid));
$articles->setState('filter.category_id.include', true); // Include

// Ordering
$articles->setState('list.ordering', ' a.created ');
$articles->setState('list.direction', 'DESC');


// Filter by language
$articles->setState('filter.language', $app->getLanguageFilter());


$relateds  = $articles->getItems();


if($rparams->get('show_pagination')){
	$this->pagination = $articles->getPagination();
}

?>
<div class="container">
<h2 class="header-related"><?php echo JText::_('TPL_TITLE_RELATED')?></h2>
<div class="tpl-inf-wrapper">
	

	<?php if(!empty($relateds)) : ?>
		

		<div id="infinity-cont" class="infinity-cont related grid-cols-<?php echo max(1, min(12, $tplparams->get('tpl_media_related_columns', 4))) ?> av-grid clearfix">
		<?php foreach ($relateds as &$ritem) : ?>
			<?php
				$ritem->slug = $ritem->alias ? ($ritem->id . ':' . $ritem->alias) : $ritem->id;
				$ritem->catslug = ($ritem->category_alias) ? ($ritem->catid . ':' . $ritem->category_alias) : $ritem->catid;
				$ritem->parent_slug = ($ritem->parent_alias) ? ($ritem->parent_id . ':' . $ritem->parent_alias) : $ritem->parent_id;
				// No link for ROOT category
				if ($ritem->parent_alias == 'root') {
					$ritem->parent_slug = null;
				}

				$ritem->text = $ritem->introtext;
				$this->ritem = $ritem;

				echo $this->loadTemplate('related_item');
			?>
		<?php endforeach ?>

		<?php if ($tplparams->get('tpl_navigation_infinity', 1)) : ?>
			<?php if ($rparams->def('show_pagination', 2) == 1  || ($rparams->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>
			<nav id="page-nav" class="pagination">
				<?php
					$urlparams = '';
					if (!empty($this->pagination->_additionalUrlParams)){
						foreach ($this->pagination->_additionalUrlParams as $key => $value) {
							$urlparams .= '&' . $key . '=' . $value;
						}
					}

					$next = $this->pagination->limitstart + $this->pagination->limit;
					$nextlink = JRoute::_($urlparams . '&' . $this->pagination->prefix . 'limitstart=' . $next);
				?>
				<a id="page-next-link" href="<?php echo $nextlink ?>" data-limit="<?php echo $this->pagination->limit; ?>" data-start="<?php echo $this->pagination->limitstart ?>"></a>
			</nav>
			<?php endif; ?>
		<?php endif; ?>

		</div>
	<?php endif ?>

	<?php if ($rparams->def('show_pagination', 2) == 1  || ($rparams->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>

		<?php if ($tplparams->get('tpl_navigation_infinity', 1)) : ?>
			<div id="infinity-next" class="infinity-next hidden">
				<div class="inf-loader">
					<img alt="<?php echo JText::_('TPL_INFINITY_NEXT')?>" src="<?php echo T3_TEMPLATE_URL ?>/images/ajax-load.gif">
				</div>
				<div class="inf-button">
					<?php echo JText::_('TPL_INFINITY_NEXT')?>
				</div>
			</div>
		<?php else : ?>
			<div class="pagination">

				<?php if ($rparams->def('show_pagination_results', 1)) : ?>
					<p class="counter pull-right">
						<?php echo $this->pagination->getPagesCounter(); ?>
					</p>
				<?php  endif; ?>
						<?php echo $this->pagination->getPagesLinks(); ?>
			</div>
		<?php endif; ?>
		
	<?php endif; ?>
</div>
</div>
