<?php
/**
 * @package		Joomla.Site
 * @subpackage	com_content
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT . '/helpers');
JHtml::addIncludePath(T3_PATH.'/html/com_content');

// If the page class is defined, add to class as suffix.
// It will be a separate class if the user starts it with a space

//register the helper class
JLoader::register('MagzHelper', T3_TEMPLATE_PATH . '/templateHelper.php');

//template params
$tplparams = JFactory::getApplication()->getTemplate(true)->params;
?>
<div class="tpl-inf-wrapper">

	<?php if ( $this->params->get('show_page_heading')!=0) : ?>
	<h1>
		<span><?php echo $this->escape($this->params->get('page_heading')); ?></span>
	</h1>
	<?php endif; ?>

	<?php if(!empty($this->lead_items) || !empty($this->intro_items)) : ?>
	<ul class="tpl-layout-switch">
		<li class="to-list"><i class="icon-th-list"></i></li>
		<li class="to-grid active"><i class="icon-th-large"></i></li>
	</ul>
	<?php endif; ?>

	<div id="infinity-cont" class="infinity-cont blog-featured<?php echo $this->pageclass_sfx, ' grid-cols-' . max(1, min(12, $this->columns)) ?> av-grid clearfix">

		<?php if (!empty($this->lead_items)) : ?>
			<?php foreach ($this->lead_items as &$item) : ?>
				<?php
					$this->item = &$item;
					echo $this->loadTemplate('item');
				?>
			<?php endforeach; ?>
		<?php endif; ?>

		<?php if (!empty($this->intro_items)) : ?>
			<?php foreach ($this->intro_items as &$item) : ?>
				<?php
					$this->item = &$item;
					echo $this->loadTemplate('item');
				?>
			<?php endforeach; ?>
		<?php endif; ?>

		<?php /* if (!empty($this->link_items)) : ?>
			<div class="items-more">
			<?php echo $this->loadTemplate('links'); ?>
			</div>
		<?php endif; */ ?>

		<?php if ($tplparams->get('tpl_navigation_infinity', 1)) : ?>
			<?php if ($this->params->def('show_pagination', 2) == 1  || ($this->params->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>
			<nav id="page-nav" class="pagination">
				<?php
					$urlparams = '';
					if (!empty($this->pagination->_additionalUrlParams)){
						foreach ($this->pagination->_additionalUrlParams as $key => $value) {
							$urlparams .= '&' . $key . '=' . $value;
						}
					}

					$next = $this->pagination->limitstart + $this->pagination->limit;
					$nextlink = JRoute::_($urlparams . '&' . $this->pagination->prefix . 'limitstart=' . $next);
				?>
				<a id="page-next-link" href="<?php echo $nextlink ?>" data-limit="<?php echo $this->pagination->limit; ?>" data-start="<?php echo $this->pagination->limitstart ?>"></a>
			</nav>
			<?php endif; ?>
		<?php endif; ?>

	</div>

	<?php if ($this->params->def('show_pagination', 2) == 1  || ($this->params->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>

		<?php if ($tplparams->get('tpl_navigation_infinity', 1)) : ?>
			<div id="infinity-next" class="infinity-next hidden">
				<div class="inf-loader">
					<img alt="<?php echo JText::_('TPL_INFINITY_NEXT')?>" src="<?php echo T3_TEMPLATE_URL ?>/images/ajax-load.gif">
				</div>
				<div class="inf-button">
					<?php echo JText::_('TPL_INFINITY_NEXT')?>
				</div>
			</div>
		<?php else : ?>
			<div class="pagination">

				<?php if ($this->params->def('show_pagination_results', 1)) : ?>
					<p class="counter pull-right">
						<?php echo $this->pagination->getPagesCounter(); ?>
					</p>
				<?php  endif; ?>
						<?php echo $this->pagination->getPagesLinks(); ?>
			</div>
		<?php endif; ?>
		
	<?php endif; ?>
</div>