<?php
/**
 * @package        Joomla.Site
 * @subpackage    mod_articles_latest
 * @copyright    Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license        GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

//register the helper class
JLoader::register('MagzHelper', T3_TEMPLATE_PATH . '/templateHelper.php');

$tplparams = JFactory::getApplication()->getTemplate(true)->params;
$categories = JCategories::getInstance('Content');
?>

<?php if (!empty($list)) : ?>

	<?php

	//sort those latest article by hits
	$compare = create_function('$a, $b', ' if ($a->hits == $b->hits) { return 0; } return ($a->hits < $b->hits) ? 1 : -1; ');
	uasort($list, $compare);

	$focus = array_shift($list);
	$related = MagzHelper::related($focus);

	$iparams = new JRegistry;
	$iparams->loadString($focus->attribs);

	$params = $focus->params;
	$params->merge($iparams);

	$images = json_decode($focus->images);
	$exinfo = MagzHelper::getEx($focus);
	$link = false;

	if ($params->get('show_intro', '1') == '1') {
		$focus->text = $focus->introtext . ' ' . (isset($focus->fulltext) ? $focus->fulltext : '');
	} elseif (isset($focus->fulltext)) {
		$focus->text = $focus->fulltext;
	} else {
		$focus->text = $focus->introtext;
	}

	if (!empty($images->image_intro)) {
		$intro_src = $images->image_intro;
		$intro_title = !empty($images->image_intro_caption) ? $images->image_intro_caption : $focus->title;
		$intro_alt = !empty($images->image_intro_alt) ? $images->image_intro_alt : $focus->title;
	} else {
		$isrc = MagzHelper::image($focus, $exinfo['type']);
		$intro_src = !empty($isrc['src']) ? $isrc['src'] : '';
		$intro_title = $intro_alt = $focus->title;
	}

	if ($params->get('link_titles') && $params->get('access-view')) {
		$link = JRoute::_(ContentHelperRoute::getArticleRoute($focus->slug, $focus->catid));
	}
	?>

<div class="focus-articles<?php echo $moduleclass_sfx; ?>">
	<div class="focus-item">
		<div class="focus-image clearfix">
			<?php if (!empty($intro_src)): ?>
			<div class="item-image clearfix">
			<?php endif ?>

				<?php if ($link): ?>
				<a class="article-link" href="<?php echo $link; ?>"
				   title="<?php echo htmlspecialchars($focus->title); ?>">
					<?php endif; ?>

					<?php if (!empty($intro_src)): ?>
						<?php echo MagzHelper::icon($exinfo['type']) ?>
						<img title="<?php echo htmlspecialchars($intro_title); ?>"
							 src="<?php echo htmlspecialchars($intro_src); ?>"
							 alt="<?php echo htmlspecialchars($intro_alt); ?>"/>
					<?php endif; ?>

					<?php if ($link): ?>
				</a>
				<?php endif; ?>

				<?php if ($params->get('show_category')) : ?>
					<?php $category = $categories->get($focus->catid); ?>
					<?php $catparam = MagzHelper::getParam($category); ?>
					<div class="category-name <?php echo $catparam->get('tpl_cat_color', '') ?>">
						<?php $title = htmlspecialchars($focus->category_title);
						$url = '<a href="' . JRoute::_(ContentHelperRoute::getCategoryRoute($focus->catslug)) . '">' . $title . '</a>';?>
						<?php if ($params->get('link_category') AND $focus->catslug) : ?>
							<?php echo '<span class="name">', JText::sprintf('COM_CONTENT_CATEGORY', '</span><span>' . $url . '</span>'); ?>
						<?php else : ?>
							<?php echo '<span>', JText::sprintf('COM_CONTENT_CATEGORY', '</span><span>' . $title . '</span>'); ?>
						<?php endif; ?>
					</div>
				<?php endif; ?>

				<?php if (!empty($intro_src)): ?>
			</div>
			<?php endif; ?>
		</div>

		<!-- Aside -->
		<?php if (($params->get('show_author'))
			or ($params->get('show_create_date'))
			or ($params->get('show_publish_date'))
			or ($params->get('show_parent_category'))
			or ($params->get('show_print_icon'))
			or ($params->get('show_email_icon'))
			or ($params->get('access-edit'))
		) : ?>
			<aside class="article-aside clearfix">

				<?php if (($params->get('show_author'))
					or ($params->get('show_create_date'))
					or ($params->get('show_publish_date'))
					or ($params->get('show_parent_category'))
				) : ?>
					<dl class="article-info">
						<dt class="article-info-term"><?php echo JText::_('COM_CONTENT_ARTICLE_INFO'); ?></dt>

						<?php if ($params->get('show_author') && !empty($focus->author)) : ?>
							<dd class="createdby first-child">
								<?php $author = $focus->author; ?>
								<?php $author = ($focus->created_by_alias ? $focus->created_by_alias : $author); ?>
								<?php if (!empty($focus->contactid) && $params->get('link_author') == true): ?>
									<?php $addparams = $tplparams->get('tpl_userpage_mid') ? '&Itemid=' . $tplparams->get('tpl_userpage_mid') : ''; ?>
									<?php echo '<span class="name">', JText::sprintf('COM_CONTENT_WRITTEN_BY',
										'</span><span>' . JHtml::_('link', JRoute::_('index.php?option=com_contact&view=contact' . $addparams . '&id=' . $focus->contactid), $author) . '</span>'); ?>
								<?php else : ?>
									<?php echo '<span class="name">', JText::sprintf('COM_CONTENT_WRITTEN_BY', '</span><span>' . $author . '</span>'); ?>
								<?php endif; ?>
							</dd>
						<?php endif; ?>

						<?php if ($params->get('show_publish_date')) : ?>
							<dd class="published">
								<span><?php echo MagzHelper::relTime($focus->publish_up); ?></span>
							</dd>
						<?php endif; ?>

						<?php if ($params->get('show_create_date')) : ?>
							<dd class="create">
								<span><?php echo MagzHelper::relTime($focus->created); ?></span>
							</dd>
						<?php endif; ?>

						<?php if ($params->get('show_parent_category') && $focus->parent_id != 1) : ?>
							<dd class="parent-category-name">
								<?php $title = htmlspecialchars($focus->parent_title);
								$url = '<a href="' . JRoute::_(ContentHelperRoute::getCategoryRoute($focus->parent_slug)) . '">' . $title . '</a>'; ?>
								<?php if ($params->get('link_parent_category') AND $focus->parent_slug) : ?>
									<?php echo JText::sprintf('COM_CONTENT_PARENT', '<span>' . $url . '</span>'); ?>
								<?php else : ?>
									<?php echo JText::sprintf('COM_CONTENT_PARENT', '<span>' . $title . '</span>'); ?>
								<?php endif; ?>
							</dd>
						<?php endif; ?>

					</dl>
				<?php endif; ?>

				<?php if (($params->get('show_print_icon'))
					or ($params->get('show_email_icon'))
					or ($params->get('access-edit'))
				) : ?>
					<div class="menu-edit pull-right">
						<ul class="clearfix">
							<?php if ($params->get('show_print_icon')) : ?>
								<li class="print-icon"> <?php echo JHtml::_('icon.print_popup', $focus, $params); ?> </li>
							<?php endif; ?>
							<?php if ($params->get('show_email_icon')) : ?>
								<li class="email-icon"> <?php echo JHtml::_('icon.email', $focus, $params); ?> </li>
							<?php endif; ?>
							<?php if ($params->get('access-edit')) : ?>
								<li class="edit-icon"> <?php echo JHtml::_('icon.edit', $focus, $params); ?> </li>
							<?php endif; ?>
						</ul>
					</div>
				<?php endif; ?>

			</aside>
		<?php endif; ?>
		<!-- //Aside -->

		<?php if ($params->get('show_title')) : ?>
			<header class="article-header clearfix">
				<h2 class="article-title">
					<?php if ($link) : ?>
						<a class="article-link"
						   href="<?php echo $link; ?>"> <?php echo htmlspecialchars($focus->title); ?></a>
					<?php else : ?>
						<?php echo htmlspecialchars($focus->title); ?>
					<?php endif; ?>
				</h2>
			</header>
		<?php endif; ?>

		<div class="info-article">
			<section class="article-intro clearfix">
				<?php echo MagzHelper::sanitize($focus); ?>
			</section>
			<?php if ($params->get('show_tags', 1) && !empty($focus->tags)) : ?>
				<?php $focus->tagLayout = new JLayoutFile('joomla.content.tags'); ?>
				<?php echo $focus->tagLayout->render($focus->tags->itemTags); ?>
			<?php endif; ?>
		</div>

		<?php if (!empty($related)) : ?>
			<ul class="related-links">
				<?php foreach ($related as $item) : ?>
					<?php
					$rparam = new JRegistry;
					$rparam->loadString($item->attribs);

					$item->slug = $item->alias ? ($item->id . ':' . $item->alias) : $item->id;
					$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid));
					?>
					<li class="clearfix">
						<?php if ($rparam->get('content_type', 'text') != 'text') : ?>
							<span class="marker">
								<i class="<?php echo $rparam->get('content_type') == 'video' ? 'icon-facetime-video' : 'icon-camera' ?>"></i>
							</span>
						<?php endif ?>
						<a href="<?php echo $item->link; ?>"
						   title="<?php echo $item->title; ?>"><?php echo $item->title; ?></a>
					</li>
				<?php endforeach; ?>
			</ul>
		<?php endif ?>
	</div>

	<?php if (!empty($list)) : ?>
		<ul class="latest-items">
			<?php foreach ($list as $item) : ?>
				<?php
				$iparams = new JRegistry;
				$iparams->loadString($item->attribs);

				$params = $item->params;
				$params->merge($iparams);

				$images = json_decode($item->images);
				$exinfo = MagzHelper::getEx($item);
				$link = false;

				if (!empty($images->image_intro)) {
					$intro_src = $images->image_intro;
					$intro_title = !empty($images->image_intro_caption) ? $images->image_intro_caption : $item->title;
					$intro_alt = !empty($images->image_intro_alt) ? $images->image_intro_alt : $item->title;
				} else {
					$isrc = MagzHelper::image($item, $exinfo['type']);
					$intro_src = !empty($isrc['src']) ? $isrc['src'] : '';
					$intro_title = $intro_alt = $item->title;
				}

				if ($params->get('link_titles') && $params->get('access-view')) {
					$link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid));
				}
				?>
				<li class="latest-item">
					<article>
						<div class="focus-image clearfix">
							<?php if (!empty($intro_src)): ?>
							<div class="item-image ">
							<?php endif ?>

								<?php if ($link): ?>
								<a class="article-link" href="<?php echo $link; ?>"
								   title="<?php echo htmlspecialchars($item->title); ?>">
								<?php endif; ?>

									<?php if (!empty($intro_src)): ?>
										<?php echo MagzHelper::icon($exinfo['type']) ?>
										<img title="<?php echo htmlspecialchars($intro_title); ?>"
											 src="<?php echo htmlspecialchars($intro_src); ?>"
											 alt="<?php echo htmlspecialchars($intro_alt); ?>"/>
									<?php endif; ?>

								<?php if ($link): ?>
								</a>
								<?php endif; ?>

								<?php if ($params->get('show_category')) : ?>
									<?php $category = $categories->get($item->catid); ?>
									<?php $catparam = MagzHelper::getParam($category); ?>
									<div class="category-name <?php echo $catparam->get('tpl_cat_color', '') ?>">
										<?php $title = htmlspecialchars($item->category_title);
										$url = '<a href="' . JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug)) . '">' . $title . '</a>';?>
										<?php if ($params->get('link_category') AND $item->catslug) : ?>
											<?php echo '<span class="name">', JText::sprintf('COM_CONTENT_CATEGORY', '</span><span>' . $url . '</span>'); ?>
										<?php else : ?>
											<?php echo '<span>', JText::sprintf('COM_CONTENT_CATEGORY', '</span><span>' . $title . '</span>'); ?>
										<?php endif; ?>
									</div>
								<?php endif; ?>
							<?php if (!empty($intro_src)): ?>
							</div>
							<?php endif; ?>
						</div>

						<?php if ($params->get('show_title')) : ?>
							<header class="article-header clearfix">
								<h2 class="article-title">
									<?php if ($link) : ?>
										<a class="article-link"
										   href="<?php echo $link; ?>"> <?php echo htmlspecialchars($item->title); ?></a>
									<?php else : ?>
										<?php echo htmlspecialchars($item->title); ?>
									<?php endif; ?>
								</h2>
							</header>
						<?php endif; ?>

						<!-- Aside -->
						<?php if (($params->get('show_author'))
							or ($params->get('show_create_date'))
							or ($params->get('show_publish_date'))
							or ($params->get('show_parent_category'))
							or ($params->get('show_print_icon'))
							or ($params->get('show_email_icon'))
							or ($params->get('access-edit'))
						) : ?>
							<aside class="article-aside clearfix">

								<?php if (($params->get('show_author'))
									or ($params->get('show_create_date'))
									or ($params->get('show_publish_date'))
									or ($params->get('show_parent_category'))
								) : ?>
									<dl class="article-info">
										<dt class="article-info-term"><?php echo JText::_('COM_CONTENT_ARTICLE_INFO'); ?></dt>

										<?php if ($params->get('show_author') && !empty($item->author)) : ?>
											<dd class="createdby first-child">
												<?php $author = $item->author; ?>
												<?php $author = ($item->created_by_alias ? $item->created_by_alias : $author); ?>
												<?php if (!empty($item->contactid) && $params->get('link_author') == true): ?>
													<?php $addparams = $tplparams->get('tpl_userpage_mid') ? '&Itemid=' . $tplparams->get('tpl_userpage_mid') : ''; ?>
													<?php echo '<span class="name">', JText::sprintf('COM_CONTENT_WRITTEN_BY',
														'</span><span>' . JHtml::_('link', JRoute::_('index.php?option=com_contact&view=contact' . $addparams . '&id=' . $item->contactid), $author) . '</span>'); ?>
												<?php else : ?>
													<?php echo '<span class="name">', JText::sprintf('COM_CONTENT_WRITTEN_BY', '</span><span>' . $author . '</span>'); ?>
												<?php endif; ?>
											</dd>
										<?php endif; ?>

										<?php if ($params->get('show_publish_date')) : ?>
											<dd class="published">
												<span><?php echo MagzHelper::relTime($item->publish_up); ?></span>
											</dd>
										<?php endif; ?>

										<?php if ($params->get('show_create_date')) : ?>
											<dd class="create">
												<span><?php echo MagzHelper::relTime($item->created); ?></span>
											</dd>
										<?php endif; ?>

										<?php if ($params->get('show_parent_category') && $item->parent_id != 1) : ?>
											<dd class="parent-category-name">
												<?php $title = htmlspecialchars($item->parent_title);
												$url = '<a href="' . JRoute::_(ContentHelperRoute::getCategoryRoute($item->parent_slug)) . '">' . $title . '</a>'; ?>
												<?php if ($params->get('link_parent_category') AND $item->parent_slug) : ?>
													<?php echo JText::sprintf('COM_CONTENT_PARENT', '<span>' . $url . '</span>'); ?>
												<?php else : ?>
													<?php echo JText::sprintf('COM_CONTENT_PARENT', '<span>' . $title . '</span>'); ?>
												<?php endif; ?>
											</dd>
										<?php endif; ?>

									</dl>
								<?php endif; ?>

								<?php if (($params->get('show_print_icon'))
									or ($params->get('show_email_icon'))
									or ($params->get('access-edit'))
								) : ?>
									<div class="menu-edit pull-right">
										<ul class="clearfix">
											<?php if ($params->get('show_print_icon')) : ?>
												<li class="print-icon"> <?php echo JHtml::_('icon.print_popup', $item, $params); ?> </li>
											<?php endif; ?>
											<?php if ($params->get('show_email_icon')) : ?>
												<li class="email-icon"> <?php echo JHtml::_('icon.email', $item, $params); ?> </li>
											<?php endif; ?>
											<?php if ($params->get('access-edit')) : ?>
												<li class="edit-icon"> <?php echo JHtml::_('icon.edit', $item, $params); ?> </li>
											<?php endif; ?>
										</ul>
									</div>
								<?php endif; ?>

							</aside>
						<?php endif; ?>
						<!-- //Aside -->
					</article>
				</li>
			<?php endforeach; ?>
		</ul>
	<?php endif ?>
	</div>
<?php endif ?>
