/**
 * ------------------------------------------------------------------------
 * JA Magz Template
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */


Magz = window.Magz || {};

(function($){

	$.extend(Magz, {
		keys: {
			DOWN: 40,
			ENTER: 13,
			ESCAPE: 27,
			HOME: 36,
			LEFT: 37,
			PAGE_DOWN: 34,
			PAGE_UP: 33,
			RIGHT: 39,
			SPACE: 32,
			TAB: 9,
			UP: 38
		},

		popup: {}
	});

	$(document).ready(function(){
		
		// popup preview
		Magz.popup.init = (function(){

			var iframeid = null,
				framedelay = 500,
				fdelay = 500,
				curitem = null,
				scroller = null,
				infinity = null,

				//keyboard limited event fired
				kbhdelay = 400,
				kbhid = null,

				ableaction = true,

				backurl = null,

				keys = Magz.keys,

				
				//function check iframe popup load to resize
				onload = function(){
					if(this.src == 'about:blank'){
						return;
					}
					
					//change state class
					$(document.body).addClass ('popupview-loaded');
					$('#popup-view').removeClass('popup-hide popup-loading');
					
					var ifdoc = $(this).contents().get(0);
					
					if (!ifdoc || (ifdoc.readyState && ifdoc.readyState != 'complete')){
					   return;
					}

					if (ifdoc.body && ifdoc.body.innerHTML == "false"){
						return;
					}

					$(ifdoc.body).addClass('popup-body');
					
					//set the height of iframe and initialize iscroll instance
					this.height = $(ifdoc).height();

					if($(this).data('iscroll')){
						try {
							$(this).data('iscroll').destroy();
						} catch (e) {

						}
					}

					var ifmscroller = new iScroll(this.parentNode, {vScrollbar: true, hScrollbar: false, scrollbarClass: 'popup-tracker', useTransform: Magz.hasTouch, scroller: (Magz.hasTouch ? ifdoc.body : null) });
					$(this).data('iscroll', ifmscroller).addClass('loaded');
					
					//replace links
					$(ifdoc.body).find('a').each(function(){
						if(!this.onclick && $(this).attr('target') != '_blank'){
							$(this).attr('target', '_parent');
						}
					});

					//compatible
					if($.browser.opera || $.browser.mozilla || ($.browser.msie && $.browser.version >= 9)){
						$(ifdoc).on('mousewheel.iscroll', function(e, which){
							ifmscroller._wheel(e, which);
						});
					} else if($.browser.msie && $.browser.version < 9){
						ifdoc.onmousewheel = function(e){
							if(ifmscroller){
								ifmscroller._wheel((e || this.window.event).wheelDelta/120);
							}
						};
					}

					//set current scroller instance
					scroller = ifmscroller;
					
					//auto resize this iframe
					autoresize(curitem && this);
				},

				showup = function (pitem) {

					var parent = pitem.addClass('showup');

					clearTimeout(parent.data('shid'));

					//change state class
					$(document.body).addClass ('popupview-loaded');
					$('#popup-view').removeClass('popup-hide popup-loaded popup-loading');

					//animate this popup
					if(curitem && parent.hasClass('current')){
						
						var citem = $(curitem),
							fromoffset = citem.offset(),
							toitem = $('#popup-content'),
							tooffset = toitem.offset(),
							complete = function(){
								$('#popup-view').removeClass('popup-hidectrl');
								$(parent).css(Magz.support.transform, 'none');
							};

						if(Magz.support.transform){

							$(parent)
								.removeClass('animate')
								.css({
									top: '',
									opacity: 0
								});

							setTimeout(function(){
								$(parent)
									.addClass('animate')
									.css('opacity', 1);

								if($.support.transition){
									
									$(parent).one($.support.transition.end, complete);

								} else {
									setTimeout(complete, 600);
								}
								
							}, 0);
							
						} else {
							$(parent).removeClass('animate').css({
								opacity: 0
							}).animate({
								opacity: 1
							}, {
								duration: 600,
								complete: function(){
									$('#popup-view').removeClass('popup-hidectrl');
								}
							});
						}

					}
				},

				//when first open the popup
				startpopup = function(e) {

					if((e.which && e.which != 1)){
						return false;
					}

					//not support popup in small screen size
					if($(window).width() < 768){
						return true;
					}

					// check if window is smaller than popup width - 768px or if we already open a popup
					if($(document.body).hasClass ('popupopening') || $(document.body).hasClass ('popupview')){
						return false;
					}

					$(document.body).addClass('popupopening');

					//wait for the slide effect complete effect
					//should we check for current index?
					var item = $(this).closest('.items').addClass('poping').get(0);

					//attach keyboard event
					$(document.documentElement).on('keydown.magzpopup', keyhandle);

					// add popup class to body
					$(document.body).addClass ('popupview');
					$('#popup-view').addClass('popup-hide popup-hidectrl');

					//set the open to current active
					var popupitem = openpopup(item).addClass('current');
					popupitem.data('shid', setTimeout(function(){
						showup(popupitem);
					}, 2000 + (Magz.hasTouch ? 1000 : 0)));

					scroller = popupitem.find('iframe').data('iscroll');
					
					return false;
				},

				openpopup = function(item) {
					
					//merge url params
					var url = ($(item).find('.event-link').eq(0).attr('href') || ''),
						urlparts = url.split('#');

					urlparts[0] += (urlparts[0].indexOf('?') == -1 ? '?' : '&') + 'tmpl=component&magzpopup=1';
					url = urlparts.join('#');
					
					//build the popup item
					var popupitem = $('' +
						'<div class="popup-inner">' +
							'<div class="popup-inner-content"></div>' +
						'</div>').appendTo('#popup-content');
	
						popupitem
							.find('.popup-inner-content')
							.html ($('<iframe class="popup-iframe" src="' + url + '" scrolling="no" frameborder="0" />')
							.on('load', onload));

					//add state class
					$('#popup-view').removeClass('popup-loaded').addClass('popup-loading');

					curitem = item;
					$(item).addClass('poping'); //re-add

					return popupitem;
				},

				onresize = function(){
					var jiframe = $('#popup-content').find('.current iframe.loaded');
					
					if(jiframe.length){
						var ifmdoc = jiframe.contents();

						if(ifmdoc.length){

							if(scroller){
								var ifbody = ifmdoc.find('body'),
									padding = ifbody.outerHeight(true) - ifbody.height(),
									height = parseFloat(jiframe.attr('height')),
									nheight = ifmdoc.height();

								//extend the time span
								fdelay = fdelay * 2;

								if(!(jiframe.data('fixed') && height + padding <= nheight) || (height + padding < nheight) || (height - padding > nheight)){
									if(!((height + padding < nheight) || (height - padding > nheight))){
										jiframe.data('fixed', 1);
									}

									var scroll = scroller.y,
										nheight = 0;

									//try
									scroll && scroller.scrollTo(0, 0);
									nheight = ifmdoc.height();

									//restore
									if(nheight != height){
										jiframe.attr('height', nheight);
										scroller.refresh();
									}

									scroll && scroller.scrollTo(0, Math.max(scroll, -nheight + ($('#popup-content').height() || 0)));
									
									fdelay = framedelay;
								}
							}

							iframeid = setTimeout(onresize, fdelay);
						}
					}
				},

				autoresize = function(iframe){
					clearTimeout(iframeid);
					
					if(iframe){
						fdelay = framedelay;
						iframeid = setTimeout(onresize, fdelay);
					}
				},

				closepopup = function(e){

					//no propagate event
					if(e){
						e.stopPropagation();
						e.preventDefault();
					}

					//check for timeout
					if(!ableaction){
						return false;
					}

					//remove timeout
					clearTimeout(iframeid);

					//remove keyboard event
					$(document.documentElement).off('keydown.magzpopup');

					//already close ?
					if(!curitem){
						return false;
					}

					if(scroller){
						scroller.destroy();
						scroller = null;
					}

					//hide popup control first
					$('#popup-view').addClass('popup-hidectrl');

					var 
						toitem = $('#popup-content'),
						citem = $(curitem).removeClass('poping'),
						parent = toitem.find('.current');

					if(parent.length){

						if(Magz.support.transform){

							$(parent)
								.removeClass('animate')
								.css('opacity', 1);

							setTimeout(function(){
								$(parent)
									.addClass('animate')
									.css('opacity', 0);
							}, 0);

							if($.support.transition){
								
								$(parent).one($.support.transition.end, collectgarbage);

							} else {
								setTimeout(collectgarbage, 600);
							}

						} else {

							$(parent).css({
								opacity: 1
							}).animate({
								opacity: 0
							}, {
								duration: 600,
								complete: collectgarbage
							});
						}

					} else {
						collectgarbage();
					}

					if(history.pushState && $.address && backurl && Magz.cleanurl(window.location.href) != backurl){
						$.address.value(backurl);
					}

					curitem = null;

					return false;
				},

				collectgarbage = function(){
					//current iframe
					var jiframe = $('#popup-content').find('iframe');
					
					if(jiframe.length){
						//fix swf object error
						jiframe.contents().find('object, embed').remove();
					}
					
					//remove class loading
					$('#popup-view').removeClass('popup-loaded popup-loading');
					
					//fix iframe IE9
					jiframe
						.off()
						.css('visibility', 'hidden');

					if(!navigator.userAgent.match(/Trident\/7\./)){
						jiframe.attr('src', 'about:blank');
					} else {
						jiframe.contents().empty();
					}

					setTimeout(function(){
						$('.popup-inner').remove();
						$(document.body).removeClass('popupview popupview-loaded popupopening');
					}, 100);
				},

				cleanup = function() {
					$('#popup-content').find('.current').css(Magz.support.transform, 'none');
					$('#popup-content').find('.prev, .next').find('iframe')
						.each(function(argument) {
							//iframe
							$(this).contents().find('object, embed').remove();

							var scroller = $(this).data('iscroll');
							if(scroller){
								scroller.destroy();
							}

							$(this)
								.off()
								.css('visibility', 'hidden');

							if(!navigator.userAgent.match(/Trident\/7\./)){
								$(this).attr('src', 'about:blank');
							} else {
								$(this).contents().empty();
							}

						});

					setTimeout(function(){
						ableaction = true;
					}, 100);
				},

				keyhandle = function(e){
					if($(document.body).hasClass('popupview')){
						
						if(e.keyCode == keys.ESCAPE){
							
							closepopup(e);

						} else if (scroller && e.keyCode == keys.UP){
							
							scroller._wheel(1);

						} else if (scroller && e.keyCode == keys.DOWN) {
							
							scroller._wheel(-1);

						} else if(scroller && e.keyCode == keys.HOME) {
							scroller.scrollTo(0, 0, 500);
						}
					}
				};


			//extend popup
			$.extend(Magz.popup, {
				keyhandle: keyhandle,
				startpopup: startpopup
			});

			//bind a live event
			return function(){
				if (!$(document.documentElement).hasClass ('no-preview')) {

					infinity = $('#infinity-cont.event-container');
					
					//click on overlay => close
					$('#popup-view, #popup-close').off('click.magzpopup').on('click.magzpopup', closepopup);

					//click on popup content => stop the propagate event
					$('#popup-content').off('click.magzpopup').on('click.magzpopup', function (e) {
						e.stopPropagation();
					});

					infinity.off('click.magzpopup').on('click.magzpopup', '.event-link', startpopup);
				}
			}
		
		})();

		//init
		Magz.popup.init();

		//enable popup
		(function(){

			//check for iframe
			try {
				if(window.parent != window && window.parent.Magz && window.parent.Magz.popup){
					$(document.documentElement).on('keydown.iscroll', function(e){
						window.parent.Magz.popup.keyhandle(e);
					});
				}
			} catch(e){
			}

			try {
				if(/tmpl=component/gi.test(window.location.href) && window.parent.Magz){
					//support K2 back to top
					$('.itemBackToTop .k2Anchor').click(function(e) {
						
						if(window.parent.Magz.popup && window.parent.Magz.popup.keyhandle){
							window.parent.Magz.popup.keyhandle({keyCode: Magz.keys.HOME});
							e.preventDefault();
						}
					});
				}
			} catch(e){
			}

		})();

	});

})(jQuery);